// ButWnd.cpp : implementation file
//

#include "stdafx.h"
#include "SeaBattle02.h"
#include "ButWnd.h"

/////////////////////////////////////////////////////////////////////////////
// CButWnd
//
CButWnd::CButWnd()
{
	mode = BT_NONE;
	IsFocus = false;
	LastPoint.x = LastPoint.y = -1;
}

CButWnd::~CButWnd()
{
}


BEGIN_MESSAGE_MAP(CButWnd, CWnd)
	//{{AFX_MSG_MAP(CButWnd)
	ON_WM_KILLFOCUS()
	ON_WM_SETFOCUS()
	ON_WM_LBUTTONDOWN()
	ON_WM_PAINT()
	ON_WM_MOUSEMOVE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CButWnd message handlers

void CButWnd::OnKillFocus(CWnd* pNewWnd) 
{
	CWnd::OnKillFocus(pNewWnd);
	IsFocus = false;	
	Invalidate();
}

void CButWnd::OnSetFocus(CWnd* pOldWnd) 
{
	CWnd::OnSetFocus(pOldWnd);
	IsFocus = true;
	Invalidate();
}

void CButWnd::OnLButtonDown(UINT nFlags, CPoint point) 
{
	int but;
	switch(mode)
	{
	case BT_SHIPS:
		but = B_PLACEMENT;
		LastPoint.x = LastPoint.y = -1;
		break;
	case BT_SINGLE:
		but = B_SINGLE;
		LastPoint.x = LastPoint.y = -1;
		break;
	}
	::SendMessage(m_Parent->m_hWnd, WM_STATIC_TO_DLG, WM_LBT_DOWN, but);
	Invalidate();
	CWnd::OnLButtonDown(nFlags, point);
}

void CButWnd::SetMode(int md, CWnd *parent)
{
	mode = md;
	m_Parent = parent;
	switch(md)
	{
	case BT_SHIPS:
		Pic.Load(JPG_BT_SHIPS);
		ActPic.Load(JPG_BT_ACT_SHIPS);
		break;
	case BT_SINGLE:
		Pic.Load(JPG_BT_SINGLE);
		ActPic.Load(JPG_BT_ACT_SINGLE);
		break;
	}
}

void CButWnd::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	RECT rect;
	GetClientRect(&rect);
	if(IsFocus)
		ActPic.Render(&dc, &rect);
	else
		Pic.Render(&dc, &rect);
}

void CButWnd::OnMouseMove(UINT nFlags, CPoint point) 
{
	RECT rect;
	GetWindowRect(&rect);
	if(Cely(rect, point))
	{
		if(!Cely(rect, LastPoint))
		{
			SetCapture();
			IsFocus = true;
			Invalidate();
		}
	}
	else
	{
		if(Cely(rect, LastPoint))
		{
			ReleaseCapture();
			IsFocus = false;
			Invalidate();
		}
	}
	LastPoint = point;
	CWnd::OnMouseMove(nFlags, point);
}

//      point   rect
bool CButWnd::Cely(RECT rect, CPoint point){
  int w, h;
  w = rect.right-rect.left;
  h = rect.bottom-rect.top;

  if(point.x >= 0 && point.y >= 0 && point.x <= w && point.y <= h) 
    return true;
  return false;
}