// Field.cpp : implementation file
//
#include "stdafx.h"
#include "SeaBattle02.h"
#include "Field.h"

// CField
IMPLEMENT_DYNAMIC(CField, CStatic)
CField::CField()
{
	m_Parent = NULL;
	for(int i=0; i<10; i++)
		for(int j=0; j<10; j++)
			m_Event[i][j] = EMPTY;
}
CField::~CField()
{
	WaterDC.DeleteDC();
	bmp.Detach();
}

BEGIN_MESSAGE_MAP(CField, CStatic)
	//{{AFX_MSG_MAP(CField)
	ON_WM_PAINT()
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDOWN()
	ON_WM_RBUTTONDOWN()
	ON_WM_CREATE()
	ON_WM_SETCURSOR()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

int CField::ReceiveMessage(int wParam, long lParam)
{
	int i, j;
	switch(wParam)
	{
	case WM_PLACEMENT:
		m_Operation = PLACEMENT;
		m_Direction = RIGHT;
		m_Decks = 4;
		m_Position.x = m_Position.y = -1;
		m_Draw = false;
		for(i=0; i<10; i++)
			for(j=0; j<10; j++)
				m_Event[i][j] = EMPTY;
		m_Count = 0;
		Invalidate();
		break;
	case WM_IS_OK:
		if(!m_Decks)
		{
			Invalidate();
			return 1;
		}
		else return 0;
	}
	return 1;
}



void CField::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	int i, j;
	RECT rect;
	char *let = "abcdefghik";
	int count;
	CPen pn1;


	GetClientRect(&rect);
	if(m_Mode == OWN_FIELD)
	{
		//   
		//,          
		dc.BitBlt(dc.m_ps.rcPaint.left, dc.m_ps.rcPaint.top,
			dc.m_ps.rcPaint.right - dc.m_ps.rcPaint.left,
			dc.m_ps.rcPaint.bottom - dc.m_ps.rcPaint.top,
			&WaterDC, dc.m_ps.rcPaint.left,
			dc.m_ps.rcPaint.top, SRCCOPY);

			//   
		for(i=(dc.m_ps.rcPaint.top/20)*20; i<=(dc.m_ps.rcPaint.bottom/20)*20; i+=20)
		{
			dc.MoveTo(dc.m_ps.rcPaint.left, i);
			dc.LineTo(dc.m_ps.rcPaint.right, i);
		}
		//   
		for(i=(dc.m_ps.rcPaint.left/20)*20; i<=(dc.m_ps.rcPaint.right/20)*20; i+=20)
		{
			dc.MoveTo(i, dc.m_ps.rcPaint.top);
			dc.LineTo(i, dc.m_ps.rcPaint.bottom);
		}
/////////////////////////////////////
		// 
		for(i=0; i<10; i++){
			for(j=0; j<10; j++)
			{
				count = 0;
				if(m_Event[i][j] == SHIP)
				{
					if((m_Event[i][j+1] == SHIP) && j+1 < 10)
					{
						count = 1;
						do
						{
							count++;
						} while( (m_Event[i][j+count] == SHIP)&& (j+count<10) );

						DrawShip(CRect(j*20, i*20, (j+count)*20, (i+1)*20), &dc);
						j+=count;
						continue;
					}

					else
					{
						if((m_Event[i+1][j] == SHIP)
							&&((m_Event[i-1][j] != SHIP) || i-1<0)
							&& i+1<10)
						{
							count = 1;
							do
							{
								count++;
							} while((m_Event[i+count][j] == SHIP)&& i+count<10);

							DrawShip(CRect(j*20, i*20, (j+1)*20, (i+count)*20), &dc);
							continue;
						}

						if(((m_Event[i+1][j] != SHIP) && i+1<10)||(i+1==10))
							if(((m_Event[i-1][j] != SHIP) && i-1 >= 0) || (i-1<0))
								if(((m_Event[i][j+1] != SHIP) && j+1<10) || (j+1==10))
									if(((m_Event[i][j-1] != SHIP) && j-1>=0) || (j-1<0))
										DrawShip(CRect(j*20, i*20, (j+1)*20, (i+1)*20), &dc);
					}//else


				}//if(m_Event[i][j] == SHIP)
			}//for(j=0; j<10; j++)
		}//for(i=0; i<10; i++)

		if(m_Draw && m_Operation == PLACEMENT) {	
			DrawShip(GetRect(), &dc);
		}
	}//if(m_Mode == OWN_FIELD)

	GetClientRect(&rect);

	if(m_Mode == NUMBERS)
	{
		dc.SetBkMode(TRANSPARENT);
		dc.TextOut(0, 4, "  1   2   3   4   5   6   7   8   9  10");
	}
	if(m_Mode == LETTERS)
	{
		dc.SetBkMode(TRANSPARENT);
		for(i=0; i<rect.bottom-rect.top; i+=20)
			dc.TextOut(8, i+2, (CString)let[i/20]);
	}
}
//-----------------------------
void CField::SetMode(int mode)
{
	m_Mode = mode;
}
//------------------------
void CField::SetParent(CWnd *wnd)
{
	RECT rect;
	CBitmap bmp;
	CDC *dc = GetDC();
	CPicture m_Fon;

	m_Parent = wnd;
	GetClientRect(&rect);
	WaterDC.CreateCompatibleDC(dc);
	bmp.CreateCompatibleBitmap(dc, rect.right, rect.bottom);
	ReleaseDC(dc);
	pOld = WaterDC.SelectObject(&bmp);

	m_Fon.Load(JPG_BACKGROUND);
	m_Fon.Render(&WaterDC, CRect(0, 0, 50, 50));

	//   5050   
	for(int i=0; i<=rect.right/50+3; i++)
		for(int j=0; j<=rect.bottom/50; j++)
			WaterDC.BitBlt(i*50, j*50, 50, 50, &WaterDC, 0, 0, SRCCOPY);
}


//---------------------------
BOOL CField::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message) 
{
	return CStatic::OnSetCursor(pWnd, nHitTest, message);
}

//--------------------
void CField::OnDestroy() 
{
	WaterDC.DeleteDC();
	bmp.DeleteObject();
	CStatic::OnDestroy();
}

void CField::OnMouseMove(UINT nFlags, CPoint point) 
{
	if(m_Mode == OWN_FIELD && m_Operation == PLACEMENT)
	{
		if(m_Position.x == -1 && (point.x/20)*20+80 <= 200)
		{
			m_Position.x = (point.x/20)*20;
			m_Position.y = (point.y/20)*20;
			m_Draw = true;
			InvalidateRect(CRect(m_Position.x, m_Position.y, m_Position.x+80, m_Position.y+20));
		}
		if(m_Position.x != (point.x/20)*20 || m_Position.y != (point.y/20)*20)
		{
			if(m_Direction == RIGHT && (point.x/20)*20 + m_Decks*20 <= 200)
			{
				m_Draw = false;
				InvalidateRect(CRect(m_Position.x, m_Position.y,
					m_Position.x + m_Decks*20, m_Position.y + 20));
				UpdateWindow();
				m_Position.x = (point.x/20)*20;
				m_Position.y = (point.y/20)*20;
				m_Draw = true;
				InvalidateRect(CRect(m_Position.x, m_Position.y,
					m_Position.x + m_Decks*20, m_Position.y + 20));
			}
			if(m_Direction == TOP && (point.y/20)*20 - (m_Decks-1)*20 >= 0)
			{
				m_Draw = false;
				InvalidateRect(CRect(m_Position.x, m_Position.y - (m_Decks-1)*20,
					m_Position.x + 21, m_Position.y+21));
				m_Position.x = (point.x/20)*20;
				m_Position.y = (point.y/20)*20;
				UpdateWindow();
				m_Draw = true;
				InvalidateRect(CRect(m_Position.x+1, m_Position.y - (m_Decks-1)*20,
					m_Position.x + 20, m_Position.y+20));
			}
			if(m_Direction == BOTTOM && (point.y/20)*20 + m_Decks*20 <= 200) 
			{
				m_Draw = false;
				InvalidateRect(CRect(m_Position.x, m_Position.y,
					m_Position.x + 21, m_Position.y + m_Decks*20 + 1));
				m_Position.x = (point.x/20)*20;
				m_Position.y = (point.y/20)*20;
				UpdateWindow();
				m_Draw = true;
				InvalidateRect(CRect(m_Position.x, m_Position.y,
					m_Position.x + 21, m_Position.y + m_Decks*20 + 1));
			}
			if(m_Direction == LEFT && (point.x/20)*20 - (m_Decks-1)*20 >= 0)
			{
				m_Draw = false;
				InvalidateRect(CRect(m_Position.x - (m_Decks-1)*20, m_Position.y,
					m_Position.x+21, m_Position.y + 21));
				m_Position.x = (point.x/20)*20;
				m_Position.y = (point.y/20)*20;
				UpdateWindow();
				m_Draw = true;
				InvalidateRect(CRect(m_Position.x - (m_Decks-1)*20, m_Position.y,
					m_Position.x+21, m_Position.y + 21));
			}
		}
	}
	CStatic::OnMouseMove(nFlags, point);
}

void CField::OnLButtonDown(UINT nFlags, CPoint point) 
{
//	POINT pos;

	if(m_Operation == PLACEMENT && m_Mode == OWN_FIELD && m_Parent && m_Draw)
	{
		if(ConvertPropertiesToMassive())
		{
			m_Count++;
			switch(m_Count)
			{
			case 1:
				m_Decks = 3;
				break;
			case 3:
				m_Decks = 2;
				break;
			case 6:
				m_Decks = 1;
				break;
			case 10:
				m_Decks = 0;
				break;
			}
		}
	}

	CStatic::OnLButtonDown(nFlags, point);
}



void CField::OnRButtonDown(UINT nFlags, CPoint point) 
{

	if(m_Mode == OWN_FIELD && m_Operation == PLACEMENT)
	{
		switch(m_Direction)
		{
		case LEFT:
			if(m_Position.y - (m_Decks-1)*20 >= 0)
			{
				m_Draw = false;
				InvalidateRect(CRect(m_Position.x - (m_Decks-1)*20, m_Position.y,
					m_Position.x+20, m_Position.y + 21));
				UpdateWindow();
				m_Draw = true;
				m_Direction = TOP;
				InvalidateRect(CRect(m_Position.x, m_Position.y - (m_Decks-1)*20,
					m_Position.x + 20, m_Position.y+21));
			}
			break;
		case TOP:
			if(m_Position.x + m_Decks*20 <= 200) 
			{
				m_Draw = false;
				InvalidateRect(CRect(m_Position.x, m_Position.y - (m_Decks-1)*20,
					m_Position.x + 21, m_Position.y+21));
				UpdateWindow();
				m_Draw = true;
				m_Direction = RIGHT;
				InvalidateRect(CRect(m_Position.x, m_Position.y,
					m_Position.x + m_Decks*20 + 1, m_Position.y + 21));
			}
			break;
		case RIGHT:
			if(m_Position.y + m_Decks*20 <= 200) 
			{
				m_Draw = false;
				InvalidateRect(CRect(m_Position.x, m_Position.y,
					m_Position.x + m_Decks*20 + 1, m_Position.y + 21));
				UpdateWindow();
				m_Draw = true;
				m_Direction = BOTTOM;
				InvalidateRect(CRect(m_Position.x, m_Position.y,
					m_Position.x + 20, m_Position.y + m_Decks*20));
			}
			break;
		case BOTTOM:
			if(m_Position.x - (m_Decks-1)*20 >= 0)
			{
				m_Draw = false;
				InvalidateRect(CRect(m_Position.x, m_Position.y,
					m_Position.x + 21, m_Position.y + m_Decks*20+1));
				m_Direction = LEFT;
				UpdateWindow();
				m_Draw = true;
				InvalidateRect(CRect(m_Position.x - (m_Decks-1)*20, m_Position.y,
					m_Position.x+20, m_Position.y + 20));
			}
			break;
		}
	}
	CStatic::OnRButtonDown(nFlags, point);
}

int CField::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CStatic::OnCreate(lpCreateStruct) == -1)
		return -1;
	HINSTANCE hInst = AfxGetInstanceHandle();
//	HBITMAP hbm = (HBITMAP)::LoadImage(hInst, "Water.bmp", IMAGE_BITMAP,
//		0, 0, LR_DEFAULTSIZE|LR_LOADFROMFILE);
//	bmp.Attach(hbm);

	m_Bmp[0] = (HBITMAP)::LoadImage(hInst, MAKEINTRESOURCE(IDB_ONE_DECK), IMAGE_BITMAP,
		0, 0, LR_DEFAULTSIZE|LR_LOADTRANSPARENT);
	m_Bmp[1] = (HBITMAP)::LoadImage(hInst, MAKEINTRESOURCE(IDB_ONE_DECK), IMAGE_BITMAP,
		0, 0, LR_DEFAULTSIZE|LR_LOADTRANSPARENT);
	m_Bmp[2] = (HBITMAP)::LoadImage(hInst, MAKEINTRESOURCE(IDB_TWO_RIGHT_DECK), IMAGE_BITMAP,
		0, 0, LR_DEFAULTSIZE|LR_LOADTRANSPARENT);
	m_Bmp[3] = (HBITMAP)::LoadImage(hInst, MAKEINTRESOURCE(IDB_TWO_BOTTOM_DECK), IMAGE_BITMAP,
		0, 0, LR_DEFAULTSIZE|LR_LOADTRANSPARENT);
	m_Bmp[4] = (HBITMAP)::LoadImage(hInst, MAKEINTRESOURCE(IDB_THREE_RIGHT_DECK), IMAGE_BITMAP,
		0, 0, LR_DEFAULTSIZE|LR_LOADTRANSPARENT);
	m_Bmp[5] = (HBITMAP)::LoadImage(hInst, MAKEINTRESOURCE(IDB_THREE_BOTTOM_DECK), IMAGE_BITMAP,
		0, 0, LR_DEFAULTSIZE|LR_LOADTRANSPARENT);
	m_Bmp[6] = (HBITMAP)::LoadImage(hInst, MAKEINTRESOURCE(IDB_FOUR_RIGHT_DECK), IMAGE_BITMAP,
		0, 0, LR_DEFAULTSIZE|LR_LOADTRANSPARENT);
	m_Bmp[7] = (HBITMAP)::LoadImage(hInst, MAKEINTRESOURCE(IDB_FOUR_BOTTOM_DECK), IMAGE_BITMAP,
		0, 0, LR_DEFAULTSIZE|LR_LOADTRANSPARENT);

	return 0;
}


bool CField::ConvertPropertiesToMassive()
{
	int i;
	int x, y, cx, cy;
	POINT pos = m_Position;
	int decks = m_Decks;
	int dir = m_Direction;

	for(i=0; i<decks; i++)
	{
		switch(dir)
		{
		case LEFT:
			if(m_Event[pos.y/20][pos.x/20-i] != EMPTY) return false;
			break;
		case TOP:
			if(m_Event[pos.y/20-i][pos.x/20] != EMPTY) return false;
			break;
		case RIGHT:
			if(m_Event[pos.y/20][pos.x/20+i] != EMPTY) return false;
			break;
		case BOTTOM:
			if(m_Event[pos.y/20+i][pos.x/20] != EMPTY) return false;
			break;
		}
	}

	if(pos.y-20>=0) y = pos.y/20-1;
	else y = pos.y/20;
	if(pos.x-20>=0) x = pos.x/20-1;
	else x = pos.x/20;
	switch(dir)
	{
	case RIGHT:
		if(pos.x+decks*20+20<=200) { cx = pos.x/20+decks+1; }
		else { cx = pos.x/20+decks; }
		if(pos.y+40<=200) cy = pos.y/20+2;
		else cy = pos.y/20+1;
		break;
	case BOTTOM:
		if(pos.y+decks*20+20<=200) cy = pos.y/20+decks+1;
		else cy = pos.y/20+decks;
		if(pos.x+40<=200) cx = pos.x/20+2;
		else cx = pos.x/20+1;
		break;
	case LEFT:
		if(pos.x+40<=200) cx = pos.x/20+2;
		else cx = pos.x/20+1;
		if(pos.y+40<=200) cy = pos.y/20+2;
		else cy = pos.y/20+1;
		if(pos.x-decks*20>=0) x = pos.x/20-decks;
		else x = pos.x/20-decks+1;
		break;
	case TOP:
		if(pos.y-decks*20>=0) y = pos.y/20-decks;
		else y = pos.y/20-decks+1;
		if(pos.y+40<=200) cy = pos.y/20+2;
		else cy = pos.y/20+1;
		if(pos.x+40<=200) cx = pos.x/20+2;
		else cx = pos.x/20+1;
		break;
	}
	cx--;
	cy--;
	for(; y<=cy; y++)
		for(i = x; i<=cx; i++)
			m_Event[y][i] = NEARSHIP;
	for(i=0; i<decks; i++)
	{
		switch(dir)
		{
		case LEFT:
			m_Event[pos.y/20][pos.x/20-i] = SHIP;
			break;
		case TOP:
			m_Event[pos.y/20-i][pos.x/20] = SHIP;
			break;
		case RIGHT:
			m_Event[pos.y/20][pos.x/20+i] = SHIP;
			break;
		case BOTTOM:
			m_Event[pos.y/20+i][pos.x/20] = SHIP;
			break;
		}
	}
	return true;
}



/*
int CField::GenerateNumber(int a)
{
	return rand()%a;
}
*/
void CField::DrawShip(RECT rect, CDC *dc)
{
	int x, y;
	int lenght, dir;
	CDC memDC;
	CBitmap bmp, *oldbmp;
	CBitmap bmpist;

	x = (rect.right - rect.left)/20;
	y = (rect.bottom- rect.top)/20;
	if(x > y) { lenght = x; dir = RT; }
	else {lenght = y; dir = BT; }

	memDC.CreateCompatibleDC(dc);
	bmpist.Attach(m_Bmp[(lenght-1)*2+dir]);
	oldbmp = memDC.SelectObject(&bmpist);
	dc->BitBlt(rect.left+1, rect.top+1, rect.right-rect.left-1,
		rect.bottom-rect.top-1, &memDC, 0, 0, SRCCOPY);

	memDC.SelectObject(oldbmp);
	memDC.DeleteDC();
	bmpist.Detach();
}

RECT CField::GetRect()
{
	RECT rect;
	if(m_Position.x == -1)
	{
		rect.left=rect.top=rect.bottom=rect.right=0;
		return rect;
	}
	switch(m_Direction)
	{
	case RIGHT:
		rect.left = m_Position.x;
		rect.top = m_Position.y;
		rect.right = m_Position.x+m_Decks*20;
		rect.bottom = m_Position.y+20;
		break;
	case TOP:
		rect.left = m_Position.x;
		rect.bottom = m_Position.y+20;
		rect.right = m_Position.x+20;
		rect.top = m_Position.y-(m_Decks-1)*20;
		break;
	case LEFT:
		rect.right = m_Position.x+20;
		rect.top = m_Position.y;
		rect.left = m_Position.x-(m_Decks-1)*20;
		rect.bottom = m_Position.y+20;
		break;
	case BOTTOM:
		rect.left = m_Position.x;
		rect.top = m_Position.y;
		rect.right = m_Position.x+20;
		rect.bottom = m_Position.y+m_Decks*20;
		break;
	}
	return rect;
}


// CField message handlers

